//extern int MIRI_DRIZZLE_BASE;

//vmag: VEGA magnitudes;
//smag: UBVRI magnitudes;

//correct distortion;
extern void MIRIshift(int img,double*x,double*y);

//add distortion;
extern void MIRIunshift(int img,double*x,double*y);

//transforms, returns values in smag[];
extern void MIRItransform(double vmag[],double dvmag[],double smag[]);

//returns VEGAMAG;
//extern double untransform(int cm,int filt,double smag[]);

//set parameters needed for MIRI;
extern void miriinitparam(void);

//initialize PSF libraries;
extern void miriinitpsf(void);

//dispose PSF libraries;
extern void mirifreepsf(void);

//calculate PSF from MIRI library;
extern int calcmiripsf(int img,float x,float y,int r,int force);

//do hotometric transformations, and output mag only;
extern double MIRIcalcmag(int img,float x0,float y0,float ct0);

//do photometric transformations, and output;
extern void MIRIoutstar(FILE*,float x,float y,photdatatype*);
extern void MIRIoutstarimg(int img,FILE*,float x,float y,photdatatype*);

//output column headers and image descriptions
extern void MIRIoutstarinfo(FILE*,int*ct);
extern char *MIRIimagestring(int img);

//aperture correction radius (10 pixels)
extern float miri_apsize(int img,float x,float y);

//put lines in .info file;
extern void writemiriinfo(void);

//correct counts in fake stars;
extern void MIRIreadfakemag(FILE*);
extern void MIRIfixfakemag(int img,float x0,float y0,double*ct0);
